unit Unit1;

interface

uses
  Windows, SysUtils, Classes, Graphics, Controls, Forms, Buttons, ExtCtrls,
  Affine;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    FRotater: TRotatePoints;
    FDragging: Boolean;
    FStartPos: TPoint;
    FBitmap: TBitmap;
  public

  end;

var
  Form1: TForm1;

implementation

uses
    Math;

{$R *.dfm}

//-----------------------------------------------------------------------------
//  RXgN^
procedure TForm1.FormCreate(Sender: TObject);
begin
    //  ]NX
    FRotater := TRotatePoints.Create();
    //  }EX쒆ǂ
    FDragging := False;
    //  _uobt@prbg}bv
    FBitmap := TBitmap.Create();
    FBitmap.Width := PaintBox1.Width;
    FBitmap.Height := PaintBox1.Height;
    PaintBox1.ControlStyle := PaintBox1.ControlStyle + [csOpaque];
    FBitmap.Canvas.Font.Assign(PaintBox1.Font);
end;

//-----------------------------------------------------------------------------
//  fXgN^
procedure TForm1.FormDestroy(Sender: TObject);
begin
    FBitmap.Free();
    FRotater.Free();
end;

//-----------------------------------------------------------------------------
//  `Cxg
procedure TForm1.PaintBox1Paint(Sender: TObject);
var
    OldBkMode: Integer;
begin
    //  wihԂ
    FBitmap.Canvas.FillRect(PaintBox1.ClientRect);

    //  ]̒Slp`̒SɎĂ
    FRotater.SetCenterOfPts();

    //  ]EsړEgks
    FRotater.Execute();

    //  O̎lp`ŕ`
    FBitmap.Canvas.Pen.Color := clBlue;
    FRotater.DrawOriginal(FBitmap.Canvas, False);

    //  ̎lp`Ԃŕ`
    FBitmap.Canvas.Pen.Color := clRed;
    FRotater.DrawResult(FBitmap.Canvas, False);
    FBitmap.Canvas.Pen.Color := clBlack;

    //  p[^o
    OldBkMode := SetBkMode(FBitmap.Canvas.Handle, TRANSPARENT);
    FBitmap.Canvas.TextOut(0,  0, FormatFloat('X = 0.00', FRotater.TranslateX));
    FBitmap.Canvas.TextOut(0, 12, FormatFloat('Y = 0.00', FRotater.TranslateY));
    FBitmap.Canvas.TextOut(0, 24, FormatFloat('Radian = 0.00', FRotater.Radian));
    FBitmap.Canvas.TextOut(0, 36, FormatFloat('Rate = 0.00', FRotater.Rate));
    SetBkMode(FBitmap.Canvas.Handle, OldBkMode);

    //  _uobt@ʂɓ]
    BitBlt(PaintBox1.Canvas.Handle, 0, 0, PaintBox1.Width, PaintBox1.Height,
            FBitmap.Canvas.Handle, 0, 0, SRCCOPY);
end;

//-----------------------------------------------------------------------------
//  Jn
procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    //  쒆tOON
    FDragging := True;
    //  Jn_L^
    FStartPos := Point(X, Y);

    //  `惂[h
    if (SpeedButton1.Down) then
    begin
        //  蒼
        FRotater.Clear();
    end;

    PaintBox1.Repaint();
end;

//-----------------------------------------------------------------------------
//  쒆
procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
    Pt: TPoint;
begin
    //  ̓_L^
    Pt := Point(X, Y);

    //  쒆tOONȂ
    if (FDragging) then
    begin
        //  `惂[h
        if (SpeedButton1.Down) then
        begin
            //  ΏۂƂȂ_̔zݒ肷
            FRotater.SetPoint(Rect(FStartPos, Pt));
        end

        //  sړ[h
        else if (SpeedButton2.Down) then
        begin
            //  Ɉړ
            FRotater.TranslateX := FRotater.TranslateX + (Pt.X - FStartPos.X);
            //  cɈړ
            FRotater.TranslateY:= FRotater.TranslateY + (Pt.Y - FStartPos.Y);
            //  ̑ɔďJn_XV
            FStartPos := Pt;
        end

        //  ]ړ[h
        else if (SpeedButton3.Down) then
        begin
            //  ]
            FRotater.Radian := FRotater.Radian + DegToRad(Pt.X - FStartPos.X);
            //  ](͂ȂĂeXgɂ͂Ȃ邯ǂł)
            FRotater.Radian := FRotater.Radian + DegToRad(Pt.Y - FStartPos.Y);
            //  ̑ɔďJn_XV
            FStartPos := Pt;
        end

        //  g僂[h
        else if (SpeedButton4.Down) then
        begin
            //  g傠邢͏k
            FRotater.Rate := FRotater.Rate + DegToRad(Pt.X - FStartPos.X);
            //  g傠邢͏k()
            FRotater.Rate := FRotater.Rate + DegToRad(Pt.Y - FStartPos.Y);
            //  ̑ɔďJn_XV
            FStartPos := Pt;
        end;

        PaintBox1.Repaint();
    end;
end;

//-----------------------------------------------------------------------------
//  m
procedure TForm1.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
    Pt: TPoint;
begin
    Pt := Point(X, Y);

    if (FDragging) then
    begin
        FDragging := False;

        //  `惂[h
        if (SpeedButton1.Down) then
        begin
            //  ŏIIȎlp`ݒ
            FRotater.SetPoint(Rect(FStartPos, Pt));
        end

        //  sړ[h
        else if (SpeedButton2.Down) then
        begin
            FRotater.TranslateX := FRotater.TranslateX + (Pt.X - FStartPos.X);
            FRotater.TranslateY:= FRotater.TranslateY + (Pt.Y - FStartPos.Y);
            FStartPos := Pt;
        end

        //  ]ړ[h
        else if (SpeedButton3.Down) then
        begin
            FRotater.Radian := FRotater.Radian + DegToRad(Pt.X - FStartPos.X);
            FRotater.Radian := FRotater.Radian + DegToRad(Pt.Y - FStartPos.Y);
            FStartPos := Pt;
        end

        //  g僂[h
        else if (SpeedButton4.Down) then
        begin
            FRotater.Rate := FRotater.Rate + DegToRad(Pt.X - FStartPos.X);
            FRotater.Rate := FRotater.Rate + DegToRad(Pt.Y - FStartPos.Y);
            FStartPos := Pt;
        end;

        PaintBox1.Repaint();
    end;
end;

end.
